unit _Section;

INTERFACE

uses
  Classes, Controls, Dialogs, ExtCtrls, Forms, Graphics, Math, StdCtrls,
  StrUtils, SysUtils, SpinHex;

type
  TForm4 = class(TForm)
    btnRangeAnalysis: TButton;
    Edit1: TEdit;
    ehRangeBegin: TEasyHex;
    ehRangeEnd: TEasyHex;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    lb1: TLabel;
    lb2: TLabel;
    lb3: TLabel;
    lb4: TLabel;
    lb5: TLabel;
    PaintBox1: TPaintBox;
    Panel1: TPanel;
    procedure btnRangeAnalysisClick(Sender: TObject);
    procedure ehRangeBeginKeyPress(Sender: TObject; var Key: Char);
    procedure ehRangeEndKeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
  private
  public
  end;

var
  Form4: TForm4;

IMPLEMENTATION

uses _Main;

{$R *.dfm}

const LMARGIN = 10;      //   
      BMARGIN = 26;      //   
      TMARGIN = 10;      //   

var arByte: array of record
                     value: Integer;  //    
                     h: Word;         //,         
                     end;
    MaxValueInArray: Integer;   //    'value'    arByte;
    LengthOfRange: Integer;     //   (=    'value'   arByte)
    iSelectedMeaning: Integer;  // ,     


////////////////////////////////////////////////////////////////////////////////////////////
//                     
////////////////////////////////////////////////////////////////////////////////////////////

//>   ,     PaintBox1 
//>    
procedure HeightCalcutlation;
var hght: Integer;  //"" ( ),       
    i: Integer;
    r: Real;   //     
begin
  hght := Form4.PaintBox1.Height-BMARGIN;
  r := (hght-TMARGIN)/MaxValueInArray;  //     1 
  For i:=0 to 255 do
     arByte[i].h:=hght-Round(arByte[i].value*r);
end;


//>     PaintBox1  
//> (   ,    )
procedure ShowScheme;
var hght: Integer;   //"" ( ),       
    i,x: Integer;
    bool: Boolean;   // 
begin
  With Form4.PaintBox1.Canvas do
      begin
      bool := true;
      hght := Form4.PaintBox1.Height-BMARGIN;
      x := LMARGIN;

      For i:=0 to 255 do
         begin
         if bool
           then begin
                Brush.Color:=clBlue;
                bool:=false;
                end
           else begin
                Brush.Color:=clRed;
                bool:=true;
                end;
         If i=iSelectedMeaning
           then Brush.Color:=clLime;
         FillRect(Rect(x,arByte[i].h,x+3,hght));
         Inc(x,3);
         end;

      Brush.Color:=clWhite;
      end;
end;





////////////////////////////////////////////////////////////////////////////////////////////
//                             
////////////////////////////////////////////////////////////////////////////////////////////

//>  :   arByte,    ,
//>         
procedure TForm4.btnRangeAnalysisClick(Sender: TObject);
var iBegin, iEnd: Integer;  //      
    i: Integer;
    str: String;
begin
  iBegin := ehRangeBegin.Value;
  iEnd := ehRangeEnd.Value;
  If iBegin>iEnd
    then begin
         MessageDlg('    . , .',
                    mtWarning, [mbOK], 0);
         EXIT;
         end;
  LengthOfRange := succ(iEnd-iBegin);

  For i:=0 to 255 do        //  arByte    
     arByte[i].value:=0;

  For i:=iBegin to iEnd do    //     
     Inc(arByte[arFile[i]].value);

  MaxValueInArray := arByte[0].value;  // ,   ,
  For i:=1 to 255 do                   //       
     if arByte[i].value>MaxValueInArray
       then MaxValueInArray:=arByte[i].value;

  HeightCalcutlation;   //      h  arByte

  lb4.Caption := Format('  :'#9#9'%0:x h = %0:d d'#13+
                        '  :'#9'%1:x h = %1:d d'#13+
                        ' :'#9#9#9'%2:x h = %2:d d'#13+
                        '    :'#9'%3f%%',
                        [iBegin,iEnd,LengthOfRange,LengthOfRange/Length(arFile)*100]);
  lb5.Caption := '';
  iSelectedMeaning := -1;
  str := ShowCode(iBegin,LengthOfRange,36);
  Edit1.Text := LeftStr(str,pred(Length(str) shr 1));
  PaintBox1.Canvas.FillRect(Rect(0,0,PaintBox1.Width,PaintBox1.Height));
  PaintBox1Paint(nil);
end;


//>  
procedure TForm4.ehRangeBeginKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then btnRangeAnalysisClick(nil);
end;
procedure TForm4.ehRangeEndKeyPress(Sender: TObject; var Key: Char);
begin
  if key=#13 then btnRangeAnalysisClick(nil);
end;


//>     
procedure TForm4.FormActivate(Sender: TObject);
begin
  MaxValueInArray := -1;
  SetLength(arByte,256);
  ehRangeBegin.ValueMax := Form1.EasyHex11.ValueMax;
  ehRangeBegin.Value := Form1.EasyHex11.Value;
  ehRangeBegin.IsSystemHex := bIsHex;
  ehRangeEnd.ValueMax := Form1.EasyHex12.ValueMax;
  ehRangeEnd.Value := Form1.EasyHex12.Value;
  ehRangeEnd.IsSystemHex := bIsHex;
  If bIsHex
    then begin
         lb2.Caption := 'h   ';
         lb3.Caption := 'h';
         end
    else begin
         lb2.Caption := 'd   ';
         lb3.Caption := 'd';
         end;
  Edit1.Text := ' 36    (+2   )';
  ehRangeBegin.SetFocus;
  ehRangeBegin.SelectAll;
end;


//>       
procedure TForm4.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  arByte := nil;
end;


//>  
procedure TForm4.FormCreate(Sender: TObject);
var d: Integer;
begin
  d := ClientOrigin.X-Left;
  Constraints.MaxWidth := 842+d*2;
  Constraints.MinWidth := Constraints.MaxWidth;
  Height := 669+ClientOrigin.Y-Top+d;

  Canvas.Pen.Color := clGray;  //   

  Panel1.Anchors := [akTop, akLeft, akBottom];
  Edit1.Anchors := [akLeft, akBottom];
end;


//>   
procedure TForm4.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If (key=ord('Q')) and (ssCtrl in shift)
    then begin
         Form1.nHexDecClick(nil);
         ehRangeBegin.IsSystemHex:=bIsHex;
         ehRangeEnd.IsSystemHex:=bIsHex;
         if bIsHex
           then begin
                lb2.Caption := 'h   ';
                lb3.Caption := 'h';
                end
           else begin
                lb2.Caption := 'd   ';
                lb3.Caption := 'd';
                end;
         end;
end;


//>        
procedure TForm4.FormPaint(Sender: TObject);
var i,x,y: Integer;
begin
  x := Edit1.Left+41;
  y := Edit1.Top+20;
    With Canvas do
      begin
      for i:=0 to 4 do
         begin
         MoveTo(x,y);
         LineTo(x,y+10);
         Inc(x,168);
         end;
      Dec(x,756);
      for i:=0 to 3 do
         begin
         MoveTo(x,y);
         LineTo(x,y+4);
         Inc(x,168);
         end;
      end;
end;


//>    
procedure TForm4.FormResize(Sender: TObject);
begin
  If MaxValueInArray<>0 then HeightCalcutlation; // 'MaxValueInArray<>0' ,        ,   MaxValueInArray   
end;                                             //  ,         ,       


//>         
//>   
procedure TForm4.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; x,
  y: Integer);
begin
  If MaxValueInArray=-1 then EXIT;

  If (x<LMARGIN) or (x>=LMARGIN+768)
    then begin
         iSelectedMeaning:=-1;
         lb5.Caption:='';
         end
    else begin
         iSelectedMeaning:=(x-LMARGIN) div 3;
         lb5.Caption := Format(':'#9#9'%2.2x'#13+
                               ' :'#9'%d'#13+
                               ' :'#9#9'%f%%',
                               [iSelectedMeaning, arByte[iSelectedMeaning].value, arByte[iSelectedMeaning].value/LengthOfRange*100]);
         end;
  ShowScheme;
end;


//>    PaintBox1
procedure TForm4.PaintBox1Paint(Sender: TObject);
const AVERAGE_FREQUENCY = 0.00390625;  //      (1/256)
var hght: Integer;       //"" ( ),       
    i,i1,i2: Integer;
    r1: Real;       //       
    bool: Boolean;  // 
begin
  If MaxValueInArray=-1 then EXIT;
  hght := PaintBox1.Height-BMARGIN;
  r1 := (LengthOfRange*AVERAGE_FREQUENCY)*(hght-TMARGIN)/MaxValueInArray; //       
  bool := true;

  With PaintBox1.Canvas do
      Begin
      i := 0;     //       ..
      i2:=hght;
      Repeat
            Inc(i);
            if bool
              then begin
                   Brush.Color:=$00F0F0F0;  // 
                   bool:=false;
                   end
              else begin
                   Brush.Color := clWhite;
                   bool:=true;
                   end;
            i1 := hght-Round(i*r1);
            FillRect(Rect(LMARGIN,i1,LMARGIN+768,i2));
            i2 := i1;     //    
      Until (i1<=TMargin);
      Brush.Color := clWhite;
      FillRect(Rect(LMARGIN,0,LMARGIN+768,TMargin));
      //---------------------------------------------------

      ShowScheme;          //    
      //---------------------------------------------------

      Pen.Color := clNavy;         //  -   
      Font.Color := clLime;
      Font.Name:='Estrangelo Edessa';
      Brush.Color := clWhite;
      i := hght-Round(r1);
      MoveTo(LMARGIN+769,i);
      LineTo(LMARGIN+774,i);
      TextOut(LMARGIN+776,i-1,'0,39%');
      MoveTo(LMARGIN+769,TMARGIN);
      LineTo(LMARGIN+774,TMARGIN);
      TextOut(LMARGIN+776,TMARGIN-1,FloatToStrF(MaxValueInArray/LengthOfRange*100,ffFixed,5,2)+'%');
      //---------------------------------------------------

      Font.Name := 'Courier';      //   '|00  0F|'
      i1 := LMARGIN;
      For i:=0 to 15 do
         begin
         MoveTo(i1,hght+2);
         LineTo(i1,hght+18);
         TextOut(i1+2,hght+2,IntToHex(i shl 4,2));
         TextOut(i1+30,hght+2,IntToHex(i shl 4+15,2));
         MoveTo(i1+47,hght+2);
         LineTo(i1+47,hght+18);
         Inc(i1,48);
         end;
      //---------------------------------------------------
      
      Brush.Color := $000080FF;   //     
      For i:=0 to 255 do
         if arByte[i].value=0
           then FillRect(Rect(LMARGIN+i*3,hght+16,LMARGIN+3+i*3,hght+19));
      Brush.Color := clWhite;
      End;
end;

end.
